/*
** remind_missed.c
*/

#include <nokix/all.h>
#include <stdio.h>

#define FLG_CALL    1
#define FLG_SMS     2
#define FLG_CLND    4

extern rexx_uint confid_main;
extern rexx_uint confid_interval;

extern const unsigned char format_list[4];
/*
extern rexx_uint format_call;
extern rexx_uint format_sms;
extern rexx_uint fcal_min;
extern rexx_uint fcal_max;
*/
extern const ringtone_t tone;

static const unsigned char interval[]={1,2,10,20}; /* in 30 seconds */
/*                                   30s,1min,5min,10min */

static unsigned char flags;
static void timer_start(void);

/*******************************************************************************/

static void timer(void)
{
   if(!flags) return;
   if(!call_status) own_play_tone(&tone,PTM_WARNING_TONE);
   timer_start();
}

static void timer_start(void)
{
   own_timer_start(timer,TT_FUNCTION,
      interval[own_get_config(confid_interval)]*(unsigned )(TICKS_PER_SECOND*30+.5));
}

static unsigned format_check(unsigned format)
{
   if( format == format_list[0] ) return FLG_CALL;
   if( format == format_list[1] ) return FLG_SMS;
   if( format >= format_list[2] && format <= format_list[3] ) return FLG_CLND;
   return 0;
}

void hook_display_standby_text(unsigned format, const nokstr_t *text)
{
   if(own_get_config(confid_main))
   {
//      printf( "DISPLAY: %2x, flags: %2x\n", format, flags );
      flags |= format_check(format);
      if(flags)
      {
         // Start timer only if it is not already running
         if(own_timer_query(timer)==TE_TIMER_NOT_FOUND) timer_start();
      }
   }
}

void hook_remove_standby_text(void)
{
//   printf( "REMOVE: %2x, flags: %2x\n", msg_argv[0], flags );
   flags &= ~format_check(msg_argv[0]);
   /* Do not kill the timer because calendar notes reset the standby text every minute.
      If the timer is killed, the countdown will start again every minute for calendar notes! */
//   if(!flags) own_timer_abort(timer);
}

